



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>6.基本数据结构-双端队列（Deque）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">6.基本数据结构-双端队列（Deque）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:38:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一.双端队列（Deque）</p>
<p>　　- 概念：deque（也称为双端队列）是与队列类似的项的有序集合。它有两个端部，首部和尾部，并且项在集合中保持不变。</p>
<p>　　- 特性：deque 特殊之处在于添加和删除项是非限制性的。可以在前面或后面添加新项。同样，可以从任一端移除现有项。在某种意义上，这种混合线性结构提供了单个数据结构中的栈和队列的所有能力。</p>
<p>　　- 注意：即使 deque 可以拥有栈和队列的许多特性，它不需要由那些数据结构强制的 LIFO 和 FIFO 排序。这取决于你如何持续添加和删除操作。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1489694/201903/1489694-20190313190922762-1193686934.png" /></p>
<p>二.Python实现Deque</p>
<p>　　-&nbsp;Deque的抽象数据类型定义：Deque的抽象数据类型应该由以下结构和操作定义。其中元素可以从首部或尾部的任一端添加和移除。Deque操作如下：</p>
<ul><li><ul><li>Deque() 创建一个空的新 deque。它不需要参数，并返回空的 deque。</li>
<li>addFront(item) 将一个新项添加到 deque 的首部。它需要 item 参数 并不返回任何内容。</li>
<li>addRear(item) 将一个新项添加到 deque 的尾部。它需要 item 参数并不返回任何内容。</li>
<li>removeFront() 从 deque 中删除首项。它不需要参数并返回 item。deque 被修改。</li>
<li>removeRear() 从 deque 中删除尾项。它不需要参数并返回 item。deque 被修改。</li>
<li>isEmpty() 测试 deque 是否为空。它不需要参数，并返回布尔值。</li>
<li>size() 返回 deque 中的项数。它不需要参数，并返回一个整数。</li></ul></li></ul>
<p>　　</p>
<div>
<pre class="prettyprint linenums">class Deque:<br />
    def __init__(self):<br />
        self.items = []

    def isEmpty(self):<br />
        return self.items == []

    def addFront(self, item):<br />
        self.items.append(item)

    def addRear(self, item):<br />
        self.items.insert(0,item)

    def removeFront(self):<br />
        return self.items.pop()

    def removeRear(self):<br />
        return self.items.pop(0)

    def size(self):<br />
        return len(self.items)</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q744gqe.html">Windows安装RabbitMQ集群的几个注意点</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jmvnw9.html">&lbrack;Java入门笔记&rsqb; 面向对象编程基础（三）：成员变量和局部变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kdm269.html">First glance in Go</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyzl0m9.html">iOS 按钮小知识点总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzlj2q.html">Oracle建表插数据等等</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pwgk8.html">PCL编译历程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdemde8.html">Android系统Surface机制的SurfaceFlinger服务简要介绍和学习计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzowg08.html">浅析关于java的一些基础问题（上篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp22xjq.html">Apache Hadoop 2&period;9&period;2 的HDFS High Available模式部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p10dn8.html">jQuery文件分片上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j761w8.html">python练习题-day21</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25l0j9.html">&lbrack;Leetcode 72&rsqb;编辑距离 Edit Distance</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wpxxnq.html">idea代码快捷</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1n6d49.html">windows 下使用 sc 添加创建exe服务；</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5yvgeq.html">Spring重温&lpar;一&rpar;--Spring快速入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv4jmj8.html">django毕设之路1&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k505oq.html">【TP3&period;2&plus;Oracle】数据进行分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpr6l79.html">excel中如何将时间戳转换为日期格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwj0eq.html">Looksery Cup 2015 F - Yura and Developers 单调栈&plus;启发式合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p2lxnq.html">【Android】20&period;0 第20章 音频、视频、拍照、语音合成</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e4p3vk9.html">Android获取SD卡总容量，可用大小，机身内存总容量及可用大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5jw1dq.html">API 与 SDK</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy5ll19.html">Java服务CPU飙到99&percnt;问题排查</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy5xon9.html">Oracle总结之plsql编程（基础八）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjnkp09.html">&lowbar;&lowbar;int64 与long long 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w0knzq.html">放苹果（poj1664递归）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9606wwy9.html">SD从零开始33-37</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjnoj49.html">【Python】pydot安装失败解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7op6eg8.html">SHELL调用存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy5dz19.html">Oracle EBS 查看双节点是否做了信任</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
